Halide 22.0.0 Halide compiler and libraries

Public Member Functions | Protected Types | Protected Member Functions | List of all members
Halide::Internal::GeneratorInputImpl< T, ValueType > Class Template Reference

`#include <Generator.h>`

Inheritance diagram for Halide::Internal::GeneratorInputImpl< T, ValueType >:

## Public Member Functions
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
size_t | size () const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
const ValueType & | operator[] (size_t i) const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
const ValueType & | at (size_t i) const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
std::vector< ValueType >::const_iterator | begin () const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
std::vector< ValueType >::const_iterator | end () const
Public Member Functions inherited from Halide::Internal::GeneratorInputBase
| ~GeneratorInputBase () override
Public Member Functions inherited from Halide::Internal::GIOBase
virtual | ~GIOBase ()=default
void | set_type (const Type &type)
void | set_dimensions (int dims)
void | set_array_size (int size)
| GIOBase (const GIOBase &)=delete
GIOBase & | operator= (const GIOBase &)=delete
| GIOBase (GIOBase &&)=delete
GIOBase & | operator= (GIOBase &&)=delete

## Protected Types
using | TBase = std::remove_all_extents_t< T >

## Protected Member Functions
bool | is_array () const override
template<typename T2 = T, std::enable_if_t< !std::is_array_v< T2 > > * = nullptr>
| GeneratorInputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&(std::extent_v< T2, 0 > > 0)> * = nullptr>
| GeneratorInputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&std::extent_v< T2, 0 >==0 > * = nullptr>
| GeneratorInputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
Protected Member Functions inherited from Halide::Internal::GeneratorInputBase
| GeneratorInputBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
| GeneratorInputBase (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
Parameter | parameter () const
void | init_internals ()
void | set_inputs (const std::vector< StubInput > &inputs)
virtual void | set_def_min_max ()
void | verify_internals () override
virtual std::string | get_c_type () const =0
void | check_value_writable () const override
const char * | input_or_output () const override
void | set_estimate_impl (const Var &var, const Expr &min, const Expr &extent)
void | set_estimates_impl (const Region &estimates)
Protected Member Functions inherited from Halide::Internal::GIOBase
bool | array_size_defined () const
size_t | array_size () const
virtual bool | is_array () const
const std::string & | name () const
ArgInfoKind | kind () const
bool | gio_types_defined () const
const std::vector< Type > & | gio_types () const
Type | gio_type () const
bool | dims_defined () const
int | dims () const
const std::vector< Func > & | funcs () const
const std::vector< Expr > & | exprs () const
| GIOBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &types, int dims)
std::string | array_name (size_t i) const
virtual void | verify_internals ()
void | check_matching_array_size (size_t size) const
void | check_matching_types (const std::vector< Type > &t) const
void | check_matching_dims (int d) const
template<typename ElemType >
const std::vector< ElemType > & | get_values () const
void | check_gio_access () const
virtual void | check_value_writable () const =0
virtual const char * | input_or_output () const =0
template<>
const std::vector< Expr > & | get_values () const
template<>
const std::vector< Func > & | get_values () const

## Additional Inherited Members
Protected Attributes inherited from Halide::Internal::GeneratorInputBase
std::vector< Parameter > | parameters_
bool | inputs_set = false
Protected Attributes inherited from Halide::Internal::GIOBase
int | array_size_
const std::string | name_
const ArgInfoKind | kind_
std::vector< Type > | types_
int | dims_
std::vector< Func > | funcs_
std::vector< Expr > | exprs_
GeneratorBase * | generator {nullptr}

## Detailed Description

template<typename T, typename ValueType>
class Halide::Internal::GeneratorInputImpl< T, ValueType >

Definition at line 1582 of file Generator.h.

## Member Typedef Documentation

## ◆ TBase

template<typename T , typename ValueType >

using Halide::Internal::GeneratorInputImpl< T, ValueType >::TBase = std::remove_all_extents_t<T>
| protected

Definition at line 1584 of file Generator.h.

## Constructor & Destructor Documentation

## ◆ GeneratorInputImpl() [1/3]

template<typename T , typename ValueType >
template<typename T2 = T, std::enable_if_t< !std::is_array_v< T2 > > * = nullptr>

Halide::Internal::GeneratorInputImpl< T, ValueType >::GeneratorInputImpl | ( | const std::string & | name,
|  | ArgInfoKind | kind,
|  | const std::vector< Type > & | t,
|  | int | d
| ) |  |
| inline protected

Definition at line 1593 of file Generator.h.

## ◆ GeneratorInputImpl() [2/3]

template<typename T , typename ValueType >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&(std::extent_v< T2, 0 > > 0)> * = nullptr>

Halide::Internal::GeneratorInputImpl< T, ValueType >::GeneratorInputImpl | ( | const std::string & | name,
|  | ArgInfoKind | kind,
|  | const std::vector< Type > & | t,
|  | int | d
| ) |  |
| inline protected

Definition at line 1600 of file Generator.h.

## ◆ GeneratorInputImpl() [3/3]

template<typename T , typename ValueType >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&std::extent_v< T2, 0 >==0 > * = nullptr>

Halide::Internal::GeneratorInputImpl< T, ValueType >::GeneratorInputImpl | ( | const std::string & | name,
|  | ArgInfoKind | kind,
|  | const std::vector< Type > & | t,
|  | int | d
| ) |  |
| inline protected

Definition at line 1607 of file Generator.h.

## Member Function Documentation

## ◆ is_array()

template<typename T , typename ValueType >

bool Halide::Internal::GeneratorInputImpl< T, ValueType >::is_array | ( |  | ) | const
| inline override protected virtual

Reimplemented from Halide::Internal::GIOBase.

Definition at line 1586 of file Generator.h.

## ◆ size()

template<typename T , typename ValueType >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

size_t Halide::Internal::GeneratorInputImpl< T, ValueType >::size | ( |  | ) | const
| inline

Definition at line 1613 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access().

## ◆ operator[]()

template<typename T , typename ValueType >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

const ValueType & Halide::Internal::GeneratorInputImpl< T, ValueType >::operator[] | ( | size_t | i | ) | const
| inline

Definition at line 1619 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access().

## ◆ at()

template<typename T , typename ValueType >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

const ValueType & Halide::Internal::GeneratorInputImpl< T, ValueType >::at | ( | size_t | i | ) | const
| inline

Definition at line 1625 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access().

## ◆ begin()

template<typename T , typename ValueType >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

std::vector< ValueType >::const_iterator Halide::Internal::GeneratorInputImpl< T, ValueType >::begin | ( |  | ) | const
| inline

Definition at line 1631 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access().

## ◆ end()

template<typename T , typename ValueType >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

std::vector< ValueType >::const_iterator Halide::Internal::GeneratorInputImpl< T, ValueType >::end | ( |  | ) | const
| inline

Definition at line 1637 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access().

The documentation for this class was generated from the following file:

- src/Generator.h